#include "ortho.h"


void ortho_init(int xmin, int xmax, int ymin, int ymax)
{
  int i; char label[]="0";

  gpopen("plot ortho");
  mvopen(4);
  mvdiv(2,2,0,1,0,1);
  for (i=0; i<4; i++) {
    mvwindow(i, xmin, xmax, ymin, ymax);
    mvact(i); mvframe();
    label[0] = ORTHO_CODE(i);
    gptext(.9*xmax,.9*ymax,label,"c");
  }
  gppalette(2,"black");
}

void ortho_close(void)
{
  mvclose();
  gpclose(1);
  exit(0);
}

void ortho_poly(Poly *p, int c)
{
  int i;
  gpcolor(2);
  gpbegin('p');
  for (i = 0; i < p->n; i++) {
    switch (c) {
    case 'x': gppoint(p->v[i].y, p->v[i].z); break;
    case 'y': gppoint(p->v[i].x, p->v[i].z); break;
    case 'z': gppoint(p->v[i].x, p->v[i].y); break;
    }
  }
  gpend();
}

void ortho_plist(Poly *pl, int i)
{
  Poly *p;
  mvact(i);
  for (p = pl; p != NULL; p = p->next) 
    ortho_poly(p, ORTHO_CODE(i));
}

void ortho_csg(CsgNode *t, int i)
{
  switch(t->type) {
  case CSG_PRIM:
    ortho_prim(t->u.p, i);
    break;
  case CSG_COMP:
    ortho_csg(t->u.c.lft, i);
    ortho_csg(t->u.c.rgt, i);
    break;
  }
}

void ortho_prim(Prim *prm, int i)
{
  mvact(i);
  prim_draw(prm, ORTHO_CODE(i));
}

