#ifndef _RASTER_H_
#define _RASTER_H_


#include "context.h"
#include "aux.h"
#include "illumination.h"

#define NEXT(L) ((L)->next)
#define VERTEX(L) (L)
#define COLOR_PRI(L) (NEXT(VERTEX(L)))
#define COLOR_SEC(L) (NEXT(COLOR_PRI(L)))
#define TEXTURE(L) (NEXT(COLOR_SEC(L)))
#define LIST_HEAD(L) ((L)->head)
#define FIRST(L) (VERTEX(L))
#define SECOND(L) (COLOR_PRI(L))
#define THIRD(L) (COLOR_SEC(L))
#define FOURTH(L) (TEXTURE(L))



void raster_points(void);
void raster_line_strip(void);
void raster_line_loop(void);
void raster_lines(void);
void raster_polygon(void);
void raster_triangle_strip(void);
void raster_triangle_fan(void);    
void raster_triangles(void);
void raster_triangle(GLContext * c, Item * i0, Item * i1, Item * i2);
void raster_quad_strip(void);
void raster_quads(void);

#endif
