#!/bin/csh

set bin = ../bin
set mod = ../model

echo "************************************************"
echo "Rotation Surface and Rendering with Flat Shading\n"

setenv GP 300x300
echo -n "1) Profile Curve"
echo "  (type q to quit)\n"
$bin/ple $mod/curve.pts

# generating rotation surface
$bin/rsurf 18 < $mod/curve.pts > cyl.tl

# creating scene file
echo "scene {" > hdr.scn
echo " camera = view { from = {0, 0, -2.5}, up = {0, 1, 0}}," >> hdr.scn
echo " light = dist_light {direction = {0, 0, -1} }," >> hdr.scn
echo " object = polyobj { shape =" >> hdr.scn
cat hdr.scn cyl.tl > cyl.scn
echo "}};" >> cyl.scn

echo -n "2) Plot of Rotation Surface"
echo "  (type q to quit)\n"
$bin/splot < cyl.scn

echo -n "3) Rendering Flat Shaded Image"
echo "  (type q to quit)\n"
$bin/zflat < cyl.scn > cyl.ras
$bin/vw < cyl.ras

/bin/rm -f cyl.ras cyl.scn hdr.scn cyl.tl 



