
#include <stdio.h>
#include <stdlib.h>
#include <GL/context.h>
#include <GL/glu.h>

void errorCallback(GLenum x) {
  printf("Error\n");
}

void draw(void) 
{
   GLUquadricObj * cylinder;
   GLfloat mat_ambient[] = { 0.5, 0.5, 0.5, 1.0 };
   GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat mat_shininess[] = { 50.0 };
   GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };
   GLfloat model_ambient[] = { 0.5, 0.5, 0.5, 1.0 };

   
   glClearColor(0.0, 0.0, 0.0, 0.0);
   glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   
   glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_specular);
   glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
   glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, model_ambient);
   glLightModelf(GL_LIGHT_MODEL_COLOR_CONTROL, GL_SINGLE_COLOR);

   glEnable(GL_NORMALIZE);
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);
   glEnable(GL_SMOOTH);

   cylinder = gluNewQuadric();
   gluQuadricCallback(cylinder, GLU_ERROR, errorCallback);
   gluQuadricDrawStyle(cylinder, GLU_FILL); /* flat shaded */
   gluQuadricNormals(cylinder, GLU_SMOOTH);
   glTranslatef(0.0, -1.0, 0.0);
   glRotatef(-45.0, 1.0, 0.0, 0.0);
   gluCylinder(cylinder, 0.8, 0.6, 3.0, 15, 5);
   
}


void reshape (int w, int h)
{
  glViewport(0, 0, (GLsizei) w, (GLsizei) h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (w <= h)
    glOrtho(-2.5, 2.5, -2.5*(GLfloat)h/(GLfloat)w,
	    2.5*(GLfloat)h/(GLfloat)w, -10.0, 10.0);
  else
    glOrtho(-2.5*(GLfloat)w/(GLfloat)h,
	    2.5*(GLfloat)w/(GLfloat)h, -2.5, 2.5, -10.0, 10.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
//  glTranslatef(1.0, 0.0, 0.0);

}


int main(){
  
  GLContext * c;
  c = new_context(256,192);
  set_current_context(c);

  reshape(256, 192);
  draw();
  
  save_context_image(c,"cylinder.ras");
  delete_context(c);

}


















