
#include <stdio.h>
#include <stdlib.h>
#include <GL/context.h>
#include <GL/glu.h>

void errorCallback(GLenum x) {
  printf("Error\n");
}

void init(void) 
{
   GLUquadricObj * disk;
   GLfloat mat_ambient[] = { 0.5, 0.5, 0.5, 1.0 };
   GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat mat_shininess[] = { 50.0 };
   GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };
   GLfloat model_ambient[] = { 0.0, 0.5, 0.5, 1.0 };

   
   glClearColor(0.0, 0.0, 0.0, 0.0);
   glClear (GL_COLOR_BUFFER_BIT);
   
   glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_specular);
   glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
   glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, model_ambient);

   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   glColor3f(0.0,1.0,1.0);

   disk = gluNewQuadric();
   gluQuadricCallback(disk, GLU_ERROR, errorCallback);
   gluQuadricDrawStyle(disk, GLU_FILL); /* wireframe */
   gluQuadricNormals(disk, GLU_NONE);
   gluDisk(disk, 0.25, 1.0, 20, 4);

}


void reshape (int w, int h)
{
  glViewport(0, 0, (GLsizei) w, (GLsizei) h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (w <= h)
    glOrtho(-2.5, 2.5, -2.5*(GLfloat)h/(GLfloat)w,
	    2.5*(GLfloat)h/(GLfloat)w, -10.0, 10.0);
  else
    glOrtho(-2.5*(GLfloat)w/(GLfloat)h,
	    2.5*(GLfloat)w/(GLfloat)h, -2.5, 2.5, -10.0, 10.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

}


int main(){
  
  GLContext * c;
  c = new_context(256,192);
  set_current_context(c);

  init();
  reshape(256, 192);

  save_context_image(c,"disk.ras");
  delete_context(c);

}


















