#include <stdio.h>
#include <stdlib.h>
#include <GL/context.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

void errorCallback(GLenum x) {
  printf("Error\n");
}

void draw(void) 
{
   GLUquadricObj * sphere;
   GLfloat mat_ambient[] = { 0.5, 0.5, 0.5, 1.0 };
   GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat mat_shininess[] = { 10.0 };
   GLfloat light_position[] = { 5.0, 5.0, 5.0, 1.0 };
   GLfloat model_ambient[] = { 0.7, 0.2, 0.7, 1.0 };
   GLfloat white_light[] = {1.0, 1.0, 1.0, 1.0 };
   glClearColor(0.0, 0.0, 0.0, 0.0);
   glShadeModel(GL_SMOOTH);
   
   glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   
   glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
   glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, white_light );
//   glLightfv(GL_LIGHT0, GL_SPECULAR, white_light);
   
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, model_ambient);

   
   glEnable(GL_CULL_FACE);
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);
   glEnable(GL_NORMALIZE);
   
   
   sphere = gluNewQuadric();
   gluQuadricCallback(sphere, GLU_ERROR, errorCallback);
   gluQuadricDrawStyle(sphere, GLU_FILL); /* smooth shaded */
   gluQuadricNormals(sphere, GLU_SMOOTH);
   gluSphere(sphere, 1.0, 35, 40);
   glTranslated(1.0, 0.0, -3.0);
   gluSphere(sphere, 1.0, 35, 40);

}


void reshape (int w, int h)
{
  glViewport(0, 0, (GLsizei) w, (GLsizei) h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (w <= h)
    glOrtho(-1.5, 1.5, -1.5*(GLfloat)h/(GLfloat)w,
	    1.5*(GLfloat)h/(GLfloat)w, -10.0, 10.0);
  else
    glOrtho(-1.5*(GLfloat)w/(GLfloat)h,
	    1.5*(GLfloat)w/(GLfloat)h, -1.5, 1.5, -10.0, 10.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}


int main(){
  
  GLContext * c;
  c = new_context(256,192);
  set_current_context(c);

  
  reshape(256, 192);
  draw();


  save_context_image(c,"sphere.ras");
  delete_context(c);
  return 0;
}


















