#include <GL/context.h>
#include <GL/glu.h>
#include <stdlib.h>

void error_cb(GLenum x) {
  printf("Error\n");
}

int main(){

  GLContext * c;
  GLfloat position[] = { 0.0, 0.0, 10.0, 1.0 };
  GLfloat material_diffuse[] = {1.0, 0.0,0.0};
  GLUquadricObj * sphere;
  c = new_context(256,192);
  set_current_context(c);
  sphere = gluNewQuadric();
  gluQuadricCallback(sphere, GLU_ERROR, error_cb);
  gluQuadricDrawStyle(sphere, GLU_FILL);
  gluQuadricNormals(sphere, GLU_SMOOTH);
  
  glClearColor(0.0,0.0,0.0,0.0);
  glViewport(0,0,256,192);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-2.5,2.5,-2.5,2.5,-10.0,10.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glClear(GL_COLOR_BUFFER_BIT);
  glMaterialfv(GL_FRONT, GL_EMISSION, material_diffuse);
  glEnable(GL_LIGHTING);
  glLightModelf(GL_LIGHT_MODEL_COLOR_CONTROL, GL_SINGLE_COLOR);
  glEnable(GL_LIGHT0);
  glEnable(GL_SMOOTH);
  gluSphere(sphere, .75, 15, 10);
  save_context_image(c,"teste.ras");
  delete_context(c);

}




